"use strict";
// Standard attributes 
this.name           = "Energy Rebalance SCC"; 
this.author         = "Stranger & phkb"; 
this.copyright      = "Stranger";
this.licence        = "Creative Commons Attribution - Non-Commercial - Share Alike 3.0";
this.version        = "0.2"; 
this.description    = "Simple rebalance of default energy distribution between shields and energy banks. Version compatible with Ship Configuration."; 

// this part of original script from Energy Rebalance was modified by phkb to provide compatibility with Ship Configuration
this.shipLaunchedFromStation = function(station) 
    {
    if(worldScripts.ShipConfiguration_Core)
        {
        var sc = worldScripts.ShipConfiguration_Core;
        var p = player.ship;
        this.$aftShieldID = sc.$equipmentItemInUse("aftshields", p);
        this.$foreShieldID = sc.$equipmentItemInUse("frontshields", p);
        this.$energyUnitID = sc.$equipmentItemInUse("energy", p);
        }
    }
// original script
this.shipTakingDamage = function(amount, fromEntity, damageType)	
	{
    var p = player.ship;
    if(p.equipmentStatus(this.$energyUnitID) !== "EQUIPMENT_OK") return; // needs breakable energy unit
    if(p.fuel == 0) return;   // fuel empty - shields switch to auxiliary battery
    if(p.energy >= 64)      // transfer energy to shields
        {
        var aftShieldDelta;
        var foreShieldDelta;
        if(p.equipmentStatus(this.$aftShieldID) === "EQUIPMENT_OK" && p.aftShield < 0.25 * p.maxAftShield)
            {
            aftShieldDelta = 0.25 * p.maxAftShield - p.aftShield;
            if(aftShieldDelta > 16)
                {
                aftShieldDelta = 16;
                }
            p.aftShield += aftShieldDelta;
            p.energy -= aftShieldDelta;
            }
        if(p.equipmentStatus(this.$foreShieldID) === "EQUIPMENT_OK" && p.forwardShield < 0.25 * p.maxForwardShield)
            {
            foreShieldDelta = 0.25 * p.maxForwardShield - p.forwardShield;
            if(foreShieldDelta > 16)
                {
                foreShieldDelta = 16;
                }        
            p.forwardShield += foreShieldDelta;
            p.energy -= foreShieldDelta;
            }
        }
    else                    // transfer energy from shields
        {
        if(p.energy >= 32) return;
        if(p.aftShield == 0 && p.forwardShield == 0) return;  // both shields completely depleted
        var energyDelta;
        if(p.aftShield >= p.forwardShield)                  // transfer energy from aft shield
            {
            energyDelta = p.aftShield;
                {                
                if(energyDelta > 16)
                    {
                    energyDelta = 16;
                    }
                p.aftShield -= energyDelta;
                p.energy += energyDelta;
                }
            }
        else                                                // transfer energy from fore shield
            {
            energyDelta = p.forwardShield;
                {                
                if(energyDelta > 16)
                    {
                    energyDelta = 16;
                    }
                p.forwardShield -= energyDelta;
                p.energy += energyDelta;
                }            
            }
        }
	}